import java.awt.*;
import java.util.*;

public class Darstellung extends Canvas implements Observer{
  private Population p;
  private DatenGA basis;

  public Darstellung(Population population, DatenGA basis){
    p=population;
    this.basis = basis;
    p.addObserver(this);
    setBackground(Color.yellow);
  }

  public void paint(Graphics g){
    Rectangle r = this.getBounds();
    changeColor(g);
    //---- Zeichen der Punkte --------------
    for ( int k=0 ;k<p.getCodelaenge() ; k++ ) {
      int xWert = basis.getX()[k];
      int yWert = basis.getY()[k];
      g.fillOval(xWert,yWert,4,4);
      g.drawString(""+k,xWert,yWert);
    }
    Individuum best = p.bestes();
    int bestWert = basis.fitnesswert(best);
    changeColor(g);
    for ( int k=0 ;k<p.getCodelaenge() ; k++ ) {
      int nr1= best.getGen(k);
      int kNext = (k+1)%p.getCodelaenge();
      int nr2=best.getGen(kNext);
      int x1 = basis.getX()[nr1];
      int y1 = basis.getY()[nr1];
      int x2 = basis.getX()[nr2];
      int y2 = basis.getY()[nr2];
      g.drawLine(x1,y1,x2,y2);
    }
    changeColor(g);
    g.drawString("Minimaler Wert = "+bestWert,10,10);
    g.drawString("Nr.: "+p.getGenerationsnummer()+"       ",160,10);
    //g.drawString("Individuum: "+best.toString(),10,20);
  }

  public void update(Observable o, Object arg) {
   //System.out.println("Meldung angekommen");
   repaint();
  }// update


  private void changeColor(Graphics g){
    if( g.getColor()==Color.blue )
     g.setColor(Color.red);
     else g.setColor(Color.blue);
  }

}

